//Microcontroller End of AWESUM Project
//Packet code
#include "uip.h"
#include <string.h>
#include "udpapp.h"
#include "config.h"

//define the buffer size
#define BUFFERBYTESIZE 325 //CHANGE THIS IN UDPAPP.ino TOO

//external variables from the UDPApp.ino file
extern volatile char globalX;
extern volatile char globalBuf1[];
extern volatile char globalBuf2[];
extern volatile char globalBuf3[];

void dummy_app_appcall(void)
{
}


//initialize the WiSheild
void udpapp_init(void)
{
  uip_ipaddr_t addr;
  struct uip_udp_conn *c;

  //this is the IP address of the computer
  uip_ipaddr(&addr, 192,168,1,100);
  //port number for the computer
  c = uip_udp_new(&addr, HTONS(12346));
  if(c != NULL) {
	//other port number for the computer
    uip_udp_bind(c, HTONS(12343));
  }

	//initialize the protothread
  PT_INIT(&s.pt);
}

//this function loads the UDP packet's data into one of the three cicular buffers
static unsigned char loadBuffer(void)
{
  if(globalX==1){
    memcpy(globalBuf1,uip_appdata,BUFFERBYTESIZE);
  }
  else if(globalX==2){
    memcpy(globalBuf2,uip_appdata,BUFFERBYTESIZE);
  }  
  else if(globalX==3){
    memcpy(globalBuf3,uip_appdata,BUFFERBYTESIZE);
  }

  return 1;
}

//sent an ack back to the computer signifying tha twe want the next packet
static void sendReady(void){
  char str[] = "R\n";

  memcpy(uip_appdata, str, strlen(str));
  uip_send(uip_appdata, strlen(str));
}


int prevGlobalX=3;

//declare the protothread
static PT_THREAD(handle_connection(void))
{
	//startup the protothread
	PT_BEGIN(&s.pt);
  
  //enter infinite loop
  while(1){
    
    //NOTE #define uip_newdata()   (uip_flags & UIP_NEWDATA)
    //threaded wait until UIP sets the UIP_NEWDATA flag high
    PT_WAIT_UNTIL(&s.pt, uip_newdata());
    uip_flags &= (~UIP_NEWDATA); //clear the new data flag for the next packet
    
    //load up the cicular buffers
    loadBuffer();

	//wait for the ISR to change the array number
    while(1){
      if(prevGlobalX!=globalX) break;
    }
    
	//update the previous value for next time we compare
    prevGlobalX=globalX;
    
	//send an ack back to the computer
    sendReady();
   }

  PT_END(&s.pt);
}


void udpapp_appcall(void)
{
  handle_connection();
}
